﻿package
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.ui.Keyboard;
    import flash.events.MouseEvent;
		
	public class Level1 extends MovieClip
	{
		private var player:Player;
		private var probNewObj:int;
		private var terrain:Terrain;
		
		public function Level1()
		{
			addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
		}
		
		private function onAddedToStage(event:Event):void
		{
			removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
			
			probNewObj = 1; // the probability (in percent) that a new game object will be created in a new frame
			
			// create the player, position them, add them to the stage
			player = new Player();
			player.x = 100;
			player.y = stage.stageHeight - 250;
			addChild(player);
					
			addEventListener(Event.ENTER_FRAME, moveTerrain);
			player.addEventListener(Event.ENTER_FRAME, movePlayer);
			addEventListener(Event.ENTER_FRAME, addGameObjects);
			stage.addEventListener(KeyboardEvent.KEY_DOWN, checkKeys);

			// create and setup the terrain object 
			terrain = new Terrain();
			terrain.graphics.lineStyle(2,0x000000);
			terrain.graphics.beginFill(0x00FF00);//set the color 

			// Start defining the terrain (create the bottom edge)
			var square_commands:Vector.<int> = new Vector.<int>(); 			 
			var square_coord:Vector.<Number> = new Vector.<Number>();
			square_commands.push(1, 2);
			square_coord.push(10000,stage.stageHeight, 0,stage.stageHeight);

			//Add the main points of the terrain
			for (var i:Number = 0; i < 100; i++)
			{
				square_commands.push(2);
				square_coord.push(i*100, stage.stageHeight-Math.random()*200);		
			}

			// set the points on the terrain and add to the stage
			terrain.graphics.drawPath(square_commands, square_coord);
			addChild(terrain);
		}
		
		private function checkKeys(event:KeyboardEvent):void
		{
			if (event.keyCode == Keyboard.SPACE){
				trace("Created Projectile");
				var proj:Projectile = new Projectile();
				proj.x = player.x+30;
				proj.y = player.y;
				proj.addEventListener(Event.ENTER_FRAME, moveProjectile);
				addChild(proj);
			}		 
		}
						
		private function moveProjectile(event:Event):void
		{
			var proj:Projectile = event.target as Projectile;

			for (var i:Number = 1; i < (this.numChildren-1); i++)
			{
				if ((getChildAt(i).x != proj.x) && getChildAt(i).hitTestPoint(proj.x, proj.y, true))
				{
					trace("Removed Projectile");
					proj.removeEventListener(Event.ENTER_FRAME, moveProjectile);
					removeChild(proj);
					return;  // if we have eliminated the projectile, we do not need to continue, so return.
				}
			}

			if (proj.x > stage.stageWidth)
			{
				trace("Removed Projectile");  
				proj.removeEventListener(Event.ENTER_FRAME, moveProjectile);
				removeChild(proj);
			}
			else
			{	
				proj.x += 10;
			}
		}
				
		private function moveTerrain(event:Event):void
		{
			terrain.x += -2;
		}
		
		private function movePlayer(event:Event):void
		{
			// add code to move the player here
			// you can do it either by keyboard or by mouse
		}
		
		private function addGameObjects(event:Event):void
		{
			// put a new object on the stage at this frame?
			if (Math.ceil(Math.random()*100) <= probNewObj){
				var gameObj:GameObject = new GameObject;
				// position the object randomly, but to the right of the player
				gameObj.x = stage.stageWidth + gameObj.width/2;
				gameObj.y = Math.ceil(Math.random() * (stage.stageHeight - 100 - gameObj.height/2));
				// add object to the stage
				addChild(gameObj);
				// set the velocity of the object
				gameObj.vx = -Math.ceil((Math.random() + 0.25) * 2);
				// move the object each frame
				gameObj.addEventListener(Event.ENTER_FRAME, moveObject);
			}
		}
		
		private function moveObject(event:Event):void
		{
			var gameObj:GameObject = event.target as GameObject;
			gameObj.x += gameObj.vx;
		}
	}
}